//-----------------------------------------------------------------------
// <copyright file="IPublication.cs" company="iron9light">
//      Copyright (c) iron9light. All rights reserved.
// </copyright>
// <author>iron9light</author>
//-----------------------------------------------------------------------

namespace EventBroker
{
    using System;

    /// <summary>
    /// Represents a publication for a topic and handles the publication event.
    /// </summary>
    public interface IPublication : IDisposable
    {
        /// <summary>
        /// Gets or sets the event topic.
        /// </summary>
        /// <value>The event topic.</value>
        IEventTopic EventTopic { get; set; }

        /// <summary>
        /// Gets the publisher of the event.
        /// </summary>
        object Publisher { get; }

        /// <summary>
        /// Gets the name of the event on the <see cref="Publication.Publisher"/>.
        /// </summary>
        string EventName { get; }
    }
}