//------------------------------------------------------------------------------------------------- 
// <copyright file="ISubscription.cs" company="iron9light">
//      Copyright (c) iron9light. All rights reserved.
// </copyright>
// <author>iron9light</author>
//-------------------------------------------------------------------------------------------------

namespace EventBroker
{
    /// <summary>
    /// Represents a topic subscription.
    /// </summary>
    public interface ISubscription
    {
        /// <summary>
        /// Gets the subscriber of the event.
        /// </summary>
        object Subscriber { get; }

        /// <summary>
        /// Gets the handler method name that's subscribed to the event.
        /// </summary>
        string HandlerMethodName { get; }

        /// <summary>
        /// Gets the handler.
        /// </summary>
        /// <returns>The callback.</returns>
        EventTopicFireHandler Handler { get; }
    }
}