//-----------------------------------------------------------------------
// <copyright file="IPublicationSelectorPolicy.cs" company="iron9light">
//      Copyright (c) iron9light. All rights reserved.
// </copyright>
// <author>iron9light</author>
//-----------------------------------------------------------------------

namespace EventBrokerExtension
{
    using System.Collections.Generic;
    using System.Reflection;

    using Microsoft.Practices.ObjectBuilder2;

    /// <summary>
    /// An <see cref="IBuilderPolicy"/> that will examine the given
    /// types and return a sequence of <see cref="EventInfo"/> objects
    /// that publish one or more event topics.
    /// </summary>
    public interface IPublicationSelectorPolicy : IBuilderPolicy
    {
        /// <summary>
        /// Return the sequence of publication informations.
        /// </summary>
        /// <param name="context">Current build context.</param>
        /// <returns>Sequence of publication informations.</returns>
        IEnumerable<PublicationInfo> GetPublicationInfos(IBuilderContext context);
    }
}