//-----------------------------------------------------------------------
// <copyright file="GenericEventPublisherFixture.cs" company="iron9light">
//      Copyright (c) iron9light. All rights reserved.
// </copyright>
// <author>iron9light</author>
//-----------------------------------------------------------------------

namespace Tests.EventBrokerExtension.Configuration
{
    using System;

    using TestObjects;

    using Xunit;

    public class GenericEventPublisherFixture : ConfigurationFixtureBase
    {
        protected override string ConfigName
        {
            get { return "GenericEventPublisher"; }
        }

        [Fact]
        public void Test()
        {
            GenericEventPublisher<EventArgs> publisher = this.ResolveConfiguredObject<GenericEventPublisher<EventArgs>>();
            Assert.True(publisher.IsSubscribed);

            NormalEventSubscriber subscriber = new NormalEventSubscriber();
            this.Broker.RegisterSubscription("run", subscriber, "OnRun");

            Assert.False(subscriber.HasRun);

            publisher.DoRun();

            Assert.True(subscriber.HasRun);
        }
    }
}