//-----------------------------------------------------------------------
// <copyright file="GenericEventSubscriberFixture.cs" company="iron9light">
//      Copyright (c) iron9light. All rights reserved.
// </copyright>
// <author>iron9light</author>
//-----------------------------------------------------------------------

namespace Tests.EventBrokerExtension.Configuration
{
    using System;

    using TestObjects;

    using Xunit;

    public class GenericEventSubscriberFixture : ConfigurationFixtureBase
    {
        protected override string ConfigName
        {
            get { return "GenericEventSubscriber"; }
        }

        [Fact]
        public void Test()
        {
            GenericEventSubscriber<EventArgs> subscriber = this.ResolveConfiguredObject<GenericEventSubscriber<EventArgs>>();
            Assert.False(subscriber.HasRun);

            NormalEventPublisher publisher = new NormalEventPublisher();
            this.Broker.RegisterPublication("run", publisher, "Run");
            publisher.DoRun();

            Assert.True(subscriber.HasRun);
        }
    }
}