//-----------------------------------------------------------------------
// <copyright file="MultiEventPublisherFixture.cs" company="iron9light">
//      Copyright (c) iron9light. All rights reserved.
// </copyright>
// <author>iron9light</author>
//-----------------------------------------------------------------------

namespace Tests.EventBrokerExtension.Configuration
{
    using TestObjects;

    using Xunit;

    public class MultiEventPublisherFixture : ConfigurationFixtureBase
    {
        protected override string ConfigName
        {
            get { return "MultiEventPublisher"; }
        }

        [Fact]
        public void Test()
        {
            NormalEventPublisher publisher = this.ResolveConfiguredObject<NormalEventPublisher>();
            Assert.True(publisher.IsSubscribed);

            NormalEventSubscriber subscriber1 = new NormalEventSubscriber();
            this.Broker.RegisterSubscription("run1", subscriber1, "OnRun");

            Assert.False(subscriber1.HasRun);

            publisher.DoRun();

            Assert.True(subscriber1.HasRun);

            NormalEventSubscriber subscriber2 = new NormalEventSubscriber();
            this.Broker.RegisterSubscription("run2", subscriber2, "OnRun");

            Assert.False(subscriber2.HasRun);

            publisher.DoRun();

            Assert.True(subscriber2.HasRun);
        }
    }
}