//-----------------------------------------------------------------------
// <copyright file="MultiEventSubscriberFixture.cs" company="iron9light">
//      Copyright (c) iron9light. All rights reserved.
// </copyright>
// <author>iron9light</author>
//-----------------------------------------------------------------------

namespace Tests.EventBrokerExtension.Configuration
{
    using TestObjects;

    using Xunit;

    public class MultiEventSubscriberFixture : ConfigurationFixtureBase
    {
        protected override string ConfigName
        {
            get { return "MultiEventSubscriber"; }
        }

        [Fact]
        public void Test1()
        {
            NormalEventSubscriber subscriber = this.ResolveConfiguredObject<NormalEventSubscriber>();
            Assert.False(subscriber.HasRun);

            NormalEventPublisher publisher = new NormalEventPublisher();
            this.Broker.RegisterPublication("run1", publisher, "Run");
            publisher.DoRun();

            Assert.True(subscriber.HasRun);
        }

        [Fact]
        public void Test2()
        {
            NormalEventSubscriber subscriber = this.ResolveConfiguredObject<NormalEventSubscriber>();
            Assert.False(subscriber.HasRun);

            NormalEventPublisher publisher = new NormalEventPublisher();
            this.Broker.RegisterPublication("run2", publisher, "Run");
            publisher.DoRun();

            Assert.True(subscriber.HasRun);
        }
    }
}