//-----------------------------------------------------------------------
// <copyright file="NormalEventPublisherFixture.cs" company="iron9light">
//      Copyright (c) iron9light. All rights reserved.
// </copyright>
// <author>iron9light</author>
//-----------------------------------------------------------------------

namespace Tests.EventBrokerExtension.Configuration
{
    using TestObjects;

    using Xunit;

    public class NormalEventPublisherFixture : ConfigurationFixtureBase
    {
        protected override string ConfigName
        {
            get { return "NormalEventPublisher"; }
        }

        [Fact]
        public void Test()
        {
            NormalEventPublisher publisher = this.ResolveConfiguredObject<NormalEventPublisher>();
            Assert.True(publisher.IsSubscribed);

            NormalEventSubscriber subscriber = new NormalEventSubscriber();
            this.Broker.RegisterSubscription("run", subscriber, "OnRun");

            Assert.False(subscriber.HasRun);

            publisher.DoRun();

            Assert.True(subscriber.HasRun);
        }
    }
}