//-----------------------------------------------------------------------
// <copyright file="GenericEventPublisher.cs" company="iron9light">
//      Copyright (c) iron9light. All rights reserved.
// </copyright>
// <author>iron9light</author>
//-----------------------------------------------------------------------

namespace Tests.EventBrokerExtension.Configuration.TestObjects
{
    using System;

    public class GenericEventPublisher<T>
        where T : EventArgs
    {
        private readonly T eventArgs;

        public GenericEventPublisher(T eventArgs)
        {
            this.eventArgs = eventArgs;
        }

        public event EventHandler<T> Run;

        public bool IsSubscribed
        {
            get
            {
                return this.Run != null;
            }
        }

        public void DoRun()
        {
            if (this.Run != null)
            {
                this.Run(this, this.eventArgs);
            }
        }
    }
}