//-----------------------------------------------------------------------
// <copyright file="ParameterBaseFixture.cs" company="iron9light">
//      Copyright (c) iron9light. All rights reserved.
// </copyright>
// <author>iron9light</author>
//-----------------------------------------------------------------------

namespace Tests.EventBrokerExtension
{
    using System;
    using System.Collections.Generic;

    using global::EventBrokerExtension;

    using Microsoft.Practices.ObjectBuilder2;

    using Xunit;

    public class ParameterBaseFixture
    {
        [Fact]
        public void TypesImplicitlyConvertToTypedParameters()
        {
            List<MethodParameter> values = this.GetParameterValues(typeof(int));

            Assert.Equal(1, values.Count);
            Assert.IsType<TypedParameter>(values[0]);
        }

        [Fact]
        public void ConcreteTypesMatch()
        {
            List<MethodParameter> values = this.GetParameterValues(typeof(int), typeof(string), typeof(ParameterBaseFixture));
            Type[] expectedTypes = Sequence.Collect(typeof(int), typeof(string), typeof(ParameterBaseFixture));
            for (int i = 0; i < values.Count; ++i)
            {
                Assert.True(values[i].MatchesType(expectedTypes[i]));
            }
        }

        private List<MethodParameter> GetParameterValues(params object[] values)
        {
            return Sequence.ToList(MethodParameter.ToParameters(values));
        }
    }
}
