//-----------------------------------------------------------------------
// <copyright file="RegistrationMemberFixtureBase.cs" company="iron9light">
//      Copyright (c) iron9light. All rights reserved.
// </copyright>
// <author>iron9light</author>
//-----------------------------------------------------------------------

namespace Tests.EventBrokerExtension
{
    using global::EventBrokerExtension;

    using Microsoft.Practices.ObjectBuilder2;
    using Microsoft.Practices.Unity;

    public class RegistrationMemberFixtureBase
    {
        private readonly MockExtension mockExtension = new MockExtension();

        protected IPolicyList Policies
        {
            get
            {
                return this.mockExtension.Policies;
            }
        }

        protected IUnityContainer CreateContainer()
        {
            return new UnityContainer().AddExtension(this.mockExtension);
        }

        private class MockExtension : UnityContainerExtension
        {
            public IPolicyList Policies
            {
                get
                {
                    return this.Context.Policies;
                }
            }

            protected override void Initialize()
            {
                this.Context.Policies.SetDefault<IPublicationSelectorPolicy>(new DefaultPublicationSelectorPolicy());
            }
        }
    }
}