//-----------------------------------------------------------------------
// <copyright file="CollectionAssert.cs" company="iron9light">
//      Copyright (c) iron9light. All rights reserved.
// </copyright>
// <author>iron9light</author>
//-----------------------------------------------------------------------

namespace Tests.EventBrokerExtension.Utility
{
    using System.Collections;

    using Xunit;

    public static class CollectionAssert
    {
        public static void AreEqual(ICollection expected, ICollection actual)
        {
            if (expected != null && actual != null)
            {
                Assert.Equal(expected.Count, actual.Count);

                IEnumerator expectedEnumerator = expected.GetEnumerator();
                IEnumerator actualEnumerator = actual.GetEnumerator();
                for (int i = 0;; i++)
                {
                    bool hasNext = expectedEnumerator.MoveNext() & actualEnumerator.MoveNext();

                    if (hasNext)
                    {
                        Assert.Equal(expectedEnumerator.Current, actualEnumerator.Current);
                    }
                    else
                    {
                        return;
                    }
                }
            }

            Assert.True(false);
        }
    }
}