using System;
using System.Reflection;
using Unity.Extensions;
using Xunit;

namespace Unity.Extensions
{
    public class MethodInvocationTest
    {
        [Fact]
        public void ShouldBeAbleToChangeInputs()
        {
            MethodBase methodBase = typeof(InvocationTarget).GetMethod("FirstTarget");
            InvocationTarget target = new InvocationTarget();
            IMethodInvocation invocation = new MethodInvocation(target, methodBase, new object[] { 1, "two" });

            Assert.Equal(1, invocation.Inputs["one"]);
            invocation.Inputs["one"] = 42;
            Assert.Equal(42, invocation.Inputs["one"]);
        }

        internal class InvocationTarget : MarshalByRefObject
        {
            public string FirstTarget(int one,
                                      string two)
            {
                return "Boo!";
            }
        }
    }
}