using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace Microsoft.Practices.Unity.Interception
{
    [TestClass]
    public class InterceptInterfaceGenericMethodsInterceptionExtensionTest
    {
        [TestMethod]
        public void GenericMethodOnNonGenericInterface()
        {
            Recorder.Records.Clear();
            IUnityContainer container = new UnityContainer();
            container.AddNewExtension<InterceptionExtension>();
            container.RegisterType<IFoo, Foo>();

            IFoo obj = container.Resolve<IFoo>();
            obj.Bar(42);
            obj.Bar("world");

            Assert.AreEqual(6, Recorder.Records.Count);
            Assert.AreEqual("Before Method", Recorder.Records[0]);
            Assert.AreEqual("Passed: 42", Recorder.Records[1]);
            Assert.AreEqual("After Method", Recorder.Records[2]);
            Assert.AreEqual("Before Method", Recorder.Records[3]);
            Assert.AreEqual("Passed: world", Recorder.Records[4]);
            Assert.AreEqual("After Method", Recorder.Records[5]);
        }

        public class Foo : IFoo
        {
            [InterfaceIntercept(typeof(RecordingHandler))]
            public void Bar<T>(T value)
            {
                Recorder.Records.Add("Passed: " + value);
            }
        }

        public interface IFoo
        {
            void Bar<T>(T value);
        }
    }
}