namespace Microsoft.Practices.Unity.Interception
{
    public class RecordingHandler : IInterceptionHandler
    {
        readonly string message;

        [InjectionConstructor]
        public RecordingHandler()
        {
            message = "";
        }

        public RecordingHandler(string message)
        {
            this.message = string.Format(" ({0})", message);
        }

        public IMethodReturn Invoke(IMethodInvocation call,
                                    GetNextHandlerDelegate getNext)
        {
            Recorder.Records.Add("Before Method" + message);
            IMethodReturn result = getNext().Invoke(call, getNext);
            Recorder.Records.Add("After Method" + message);
            return result;
        }
    }
}