using System;
using System.Reflection;

namespace Microsoft.Practices.Unity.Interception
{
    public interface IInterceptionConfiguration : IUnityContainerExtensionConfigurator
    {
        void InterceptInterface<T>(MethodInfo interfaceMethod,
                                   params IInterceptionHandler[] handlers);

        void InterceptInterface(Type typeToIntercept,
                                MethodInfo interfaceMethod,
                                params IInterceptionHandler[] handlers);

        void InterceptRemoting<T>(MethodInfo method,
                                  params IInterceptionHandler[] handlers);

        void InterceptRemoting(Type typeToIntercept,
                               MethodInfo method,
                               params IInterceptionHandler[] handlers);

        void InterceptVirtual<T>(MethodInfo method,
                                 params IInterceptionHandler[] handlers);

        void InterceptVirtual(Type typeToIntercept,
                              MethodInfo method,
                              params IInterceptionHandler[] handlers);
    }
}