﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.ComponentModel;

namespace StopLight {
    public interface IStoplightView : INotifyPropertyChanged {
        Brush CurrentColor { get; set; }

        string GreenDuration { get; set; }
        string YellowDuration { get; set; }
        string RedDuration { get; set; }

        event EventHandler UpdateClicked;
        event EventHandler ForceChangeClicked;

        void SetError(string propertyName, string errorMessage);
    }

    public static class StoplightViewProperties {
        public const string CurrentColor = "CurrentColor";
        public const string GreenDuration = "GreenDuration";
        public const string YellowDuration = "YellowDuration";
        public const string RedDuration = "RedDuration";
    }
}
