﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.Generic;
using System.Reflection;
using System.Linq;

namespace Microsoft.Practices.ObjectBuilder2 {
    public static class ArrayHelper {
        public static T Find<T>(T[] array,
                Predicate<T> match) {

            foreach (var o in array) {
                if (match(o)) {
                    return o;
                }
            }

            return default(T);
        }
        public static T[] FindAll<T>(T[] array,
               Predicate<T> match) {

            List<T> list = new List<T>();
            foreach (var o in array) {
                if (match(o)) {
                    list.Add(o);
                }
            }

            return list.ToArray();  
        }

        //forums.microsoft.com/MSDN/ShowPost.aspx?PostID=1846607&SiteID=1
        public static TOutput[] ConvertAll<TInput, TOutput>(TInput[] array, Converter<TInput, TOutput> converter) {
            if (array == null) {
                throw new ArgumentNullException("array");
            }

            if (converter == null) {
                throw new ArgumentNullException("converter");
            }

            TOutput[] tempArray = new TOutput[array.Length];

            for (int i = 0; i < array.Length; i++) {
                tempArray[i] = converter(array[i]);
            }

            return tempArray;

        }
    }
}
