﻿namespace Microsoft.Practices.SLUnity.Properties {
    using System;

    internal class Resources {

        internal Resources() {
        }

        ///// <summary>
        /////   Returns the cached ResourceManager instance used by this class.
        ///// </summary>
        //[global::System.ComponentModel.EditorBrowsableAttribute(global::System.ComponentModel.EditorBrowsableState.Advanced)]
        //internal static global::System.Resources.ResourceManager ResourceManager {
        //    get {
        //        if (object.ReferenceEquals(resourceMan, null)) {
        //            global::System.Resources.ResourceManager temp = new global::System.Resources.ResourceManager("Microsoft.Practices.Unity.Properties.Resources", typeof(Resources).Assembly);
        //            resourceMan = temp;
        //        }
        //        return resourceMan;
        //    }
        //}

        /// <summary>
        ///   Overrides the current thread's CurrentUICulture property for all
        ///   resource lookups using this strongly typed resource class.
        /// </summary>
        //[global::System.ComponentModel.EditorBrowsableAttribute(global::System.ComponentModel.EditorBrowsableState.Advanced)]
        internal static global::System.Globalization.CultureInfo Culture {
            get {
                return System.Globalization.CultureInfo.CurrentCulture;
            }            
        }

        /// <summary>
        ///   Looks up a localized string similar to The provided string argument must not be empty..
        /// </summary>
        internal static string ArgumentMustNotBeEmpty {
            get {
                return "The provided string argument must not be empty.";
            }
        }

        /// <summary>
        ///   Looks up a localized string similar to The method {0}.{1}({2}) is an open generic method. Open generic methods cannot be injected..
        /// </summary>
        internal static string CannotInjectGenericMethod {
            get {
                return "The method {0}.{1}({2}) is an open generic method. Open generic methods cannot be injected.";
            }
        }

        /// <summary>
        ///   Looks up a localized string similar to The property {0} on type {1} is an indexer. Indexed properties cannot be injected..
        /// </summary>
        internal static string CannotInjectIndexer {
            get {
                return "The property {0} on type {1} is an indexer. Indexed properties cannot be injected.";
            }
        }

        /// <summary>
        ///   Looks up a localized string similar to The method {0}.{1}({2}) has at least one out parameter. Methods with out parameters cannot be injected..
        /// </summary>
        internal static string CannotInjectMethodWithOutParams {
            get {
                return "The method {0}.{1}({2}) has at least one out parameter. Methods with out parameters cannot be injected.";
            }
        }

        /// <summary>
        ///   Looks up a localized string similar to The method {0}.{1}({2}) has at least one ref parameter.Methods with ref parameters cannot be injected..
        /// </summary>
        internal static string CannotInjectMethodWithRefParams {
            get {
                return "The method {0}.{1}({2}) has at least one ref parameter.Methods with ref parameters cannot be injected.";
            }
        }

        /// <summary>
        ///   Looks up a localized string similar to The method {0}.{1}({2}) is static. Static methods cannot be injected..
        /// </summary>
        internal static string CannotInjectStaticMethod {
            get {
                return "The method {0}.{1}({2}) is static. Static methods cannot be injected.";
            }
        }

        /// <summary>
        ///   Looks up a localized string similar to The lifetime manager is already registered. Lifetime managers cannot be reused, please create a new one..
        /// </summary>
        internal static string LifetimeManagerInUse {
            get {
                return "The lifetime manager is already registered. Lifetime managers cannot be reused, please create a new one.";
            }
        }

        /// <summary>
        ///   Looks up a localized string similar to The type {0} does not have a constructor that takes the parameters ({1})..
        /// </summary>
        internal static string NoSuchConstructor {
            get {
                return "The type {0} does not have a constructor that takes the parameters ({1}).";
            }
        }

        /// <summary>
        ///   Looks up a localized string similar to The type {0} does not have a public method named {1} that takes the parameters ({2})..
        /// </summary>
        internal static string NoSuchMethod {
            get {
                return "The type {0} does not have a public method named {1} that takes the parameters ({2}).";
            }
        }

        /// <summary>
        ///   Looks up a localized string similar to The type {0} does not contain a property named {1}..
        /// </summary>
        internal static string NoSuchProperty {
            get {
                return "The type {0} does not contain a property named {1}.";
            }
        }

        /// <summary>
        ///   Looks up a localized string similar to The property {0} on type {1} is not settable..
        /// </summary>
        internal static string PropertyNotSettable {
            get {
                return "The property {0} on type {1} is not settable.";
            }
        }

        /// <summary>
        ///   Looks up a localized string similar to The property {0} on type {1} of type {2}, and cannot be injected with a value of type {3}..
        /// </summary>
        internal static string PropertyTypeMismatch {
            get {
                return "The property {0} on type {1} of type {2}, and cannot be injected with a value of type {3}.";
            }
        }

        /// <summary>
        ///   Looks up a localized string similar to Resolution of the dependency failed, type = &quot;{0}&quot;, name = &quot;{1}&quot;. Exception message is: {2}.
        /// </summary>
        internal static string ResolutionFailed {
            get {
                return "Resolution of the dependency failed, type = {0}, name = {1}. Exception message is: {2}";
            }
        }

        /// <summary>
        ///   Looks up a localized string similar to The type {1} cannot be assigned to variables of type {0}..
        /// </summary>
        internal static string TypesAreNotAssignable {
            get {
                return "The type {1} cannot be assigned to variables of type {0}.";
            }
        }
    }
}
