﻿
namespace Microsoft.Practices.ObjectBuilder2.Properties {
    using System;


    internal class Resources {

        internal Resources() {
        }


        /// <summary>
        ///   Overrides the current thread's CurrentUICulture property for all
        ///   resource lookups using this strongly typed resource class.
        /// </summary>

        internal static global::System.Globalization.CultureInfo Culture {
            get {
                return System.Globalization.CultureInfo.CurrentCulture;
            }            
        }

        /// <summary>
        ///   Looks up a localized string similar to The type {0} has multiple constructors of length {1}. Unable to disambiguate..
        /// </summary>
        internal static string AmbiguousInjectionConstructor {
            get {
                //return ResourceManager.GetString("AmbiguousInjectionConstructor", resourceCulture);
                return "The type {0} has multiple constructors of length {1}. Unable to disambiguate.";
            }
        }

        /// <summary>
        ///   Looks up a localized string similar to The current build operation (build key {2}) failed: {3} (Strategy type {0}, index {1}).
        /// </summary>
        internal static string BuildFailedException {
            get {
                return "The current build operation (build key {2}) failed: {3} (Strategy type {0}, index {1})";
            }
        }

        /// <summary>
        ///   Looks up a localized string similar to The current type, {0}, is an interface and cannot be constructed. Are you missing a type mapping?.
        /// </summary>
        internal static string CannotConstructInterface {
            get {
                return "The current type, {0}, is an interface and cannot be constructed. Are you missing a type mapping?";
            }
        }

        /// <summary>
        ///   Looks up a localized string similar to Cannot extract type from build key {0}..
        /// </summary>
        internal static string CannotExtractTypeFromBuildKey {
            get {
                return "Cannot extract type from build key {0}.";
            }
        }

        /// <summary>
        ///   Looks up a localized string similar to The method {1} on type {0} has an out parameter. Injection cannot be performed..
        /// </summary>
        internal static string CannotInjectMethodWithOutParam {
            get {
                return "The method {1} on type {0} has an out parameter. Injection cannot be performed.";
            }
        }

        /// <summary>
        ///   Looks up a localized string similar to The method {1} on type {0} is marked for injection, but it is an open generic method. Injection cannot be performed..
        /// </summary>
        internal static string CannotInjectOpenGenericMethod {
            get {
                return "The method {1} on type {0} is marked for injection, but it is an open generic method. Injection cannot be performed.";
            }
        }

        /// <summary>
        ///   Looks up a localized string similar to The parameter {0} could not be resolved when attempting to call constructor {1}..
        /// </summary>
        internal static string ConstructorParameterResolutionFailed {
            get {
                return "The parameter {0} could not be resolved when attempting to call constructor {1}.";
            }
        }

        /// <summary>
        ///   Looks up a localized string similar to An item with the given key is already present in the dictionary..
        /// </summary>
        internal static string KeyAlreadyPresent {
            get {
                return "An item with the given key is already present in the dictionary.";
            }
        }

        /// <summary>
        ///   Looks up a localized string similar to The value for parameter &quot;{1}&quot; of method {0} could not be resolved. .
        /// </summary>
        internal static string MethodParameterResolutionFailed {
            get {
                return "The value for parameter \"{1}\" of method {0} could not be resolved. ";
            }
        }

        /// <summary>
        ///   Looks up a localized string similar to Could not resolve dependency for build key {0}..
        /// </summary>
        internal static string MissingDependency {
            get {
                return "Could not resolve dependency for build key {0}.";
            }
        }

        /// <summary>
        ///   Looks up a localized string similar to The type {0} has multiple constructors marked with the InjectionConstructor attribute. Unable to disambiguate..
        /// </summary>
        internal static string MultipleInjectionConstructors {
            get {
                return "The type {0} has multiple constructors marked with the InjectionConstructor attribute. Unable to disambiguate.";
            }
        }

        /// <summary>
        ///   Looks up a localized string similar to The supplied type {0} must be an open generic type..
        /// </summary>
        internal static string MustHaveOpenGenericType {
            get {
                return "The supplied type {0} must be an open generic type.";
            }
        }

        /// <summary>
        ///   Looks up a localized string similar to The supplied type {0} does not have the same number of generic arguments as the target type {1}..
        /// </summary>
        internal static string MustHaveSameNumberOfGenericArguments {
            get {
                return "The supplied type {0} does not have the same number of generic arguments as the target type {1}.";
            }
        }

        /// <summary>
        ///   Looks up a localized string similar to The type {0} does not have an accessible constructor..
        /// </summary>
        internal static string NoConstructorFound {
            get {
                return "The type {0} does not have an accessible constructor.";
            }
        }

        /// <summary>
        ///   Looks up a localized string similar to The value for the property &quot;{0}&quot; could not be resolved..
        /// </summary>
        internal static string PropertyValueResolutionFailed {
            get {
                return "The value for the property \"{0}\" could not be resolved.";
            }
        }

        /// <summary>
        ///   Looks up a localized string similar to The provided string argument must not be empty..
        /// </summary>
        internal static string ProvidedStringArgMustNotBeEmpty {
            get {
                return "The provided string argument must not be empty.";
            }
        }
    }
}
