﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Common.Core;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace Common.Core.Testing
{
	public interface IFoo
	{

	}

	public class Foo : IFoo
	{
	}

	class ThreadLocalStorageFixture
	{
		[TestMethod]
		public void Push()
		{
			Foo foo = new Foo();
			IDisposable disposable = ThreadLocalStorage.Push<IFoo>(foo);

			Assert.IsNotNull(disposable);
		}

		[TestMethod]
		public void Peek()
		{
			Foo foo = new Foo();
			ThreadLocalStorage.Push<IFoo>(foo);

			Assert.AreSame(foo, ThreadLocalStorage.Peek<IFoo>());
		}

		[TestMethod]
		public void Dispose()
		{
			Foo foo = new Foo();
			IDisposable disposable = ThreadLocalStorage.Push<IFoo>(foo);
			disposable.Dispose();

			Assert.IsNull(ThreadLocalStorage.Peek<IFoo>());
		}
	}
}