using System;

namespace Common.Core.Configuration
{
	[AttributeUsage( AttributeTargets.Assembly, AllowMultiple = true )]
	public class ConfigurationTargetMappingAttribute : Attribute
	{
		readonly Type targetType, configurationType;

		public ConfigurationTargetMappingAttribute( Type targetType, Type configurationType )
		{
			this.targetType = targetType;
			this.configurationType = configurationType;
		}

		public Type TargetType
		{
			get { return targetType; }
		}

		public Type ConfigurationType
		{
			get { return configurationType; }
		}
	}
}