using System.Configuration;
using Microsoft.Practices.EnterpriseLibrary.Common.Configuration;

namespace Common.Core.Configuration
{
	public class DefaultNameTypeConfigurationElementCollection<ElementType, CustomElementType> : NameTypeConfigurationElementCollection<ElementType, CustomElementType> where ElementType : NameTypeConfigurationElement, new() where CustomElementType : ElementType, new()
	{
		[ConfigurationProperty( DefaultNameName, DefaultValue = null, IsRequired = true, IsKey = false )]
		public string DefaultName
		{
			get { return (string)this[DefaultNameName]; }
			set { this[DefaultNameName] = value; }
		}	const string DefaultNameName = "defaultName";

		public ElementType GetSelected()
		{
			return Get( DefaultName );
		}

		public ElementType GetItem( string name )
		{
			return Get( name ) ?? GetSelected();
		}
	}
}