using System;
using System.Collections.Generic;

namespace Common.Core.Objects
{
	public class ObjectFindingEventArgs<SourceType,ObjectType> : EventArgs
	{
		readonly IEnumerable<ObjectType> list;
		readonly SourceType source;

		public ObjectFindingEventArgs( IEnumerable<ObjectType> list, SourceType source )
		{
			this.list = list;
			this.source = source;
		}

		public SourceType Source
		{
			get { return source; }
		}

		public IEnumerable<ObjectType> List
		{
			get { return list; }
		}

		public ObjectType Result { get; set; }
	}
}