﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Common.Core;

namespace Common.Unity.Extensions.Configuration
{
	[AttributeUsage( AttributeTargets.Class, AllowMultiple = true )]
	public class ObjectConfiguratorAttribute : Attribute
	{
		readonly Type objectConfiguratorType;

		public ObjectConfiguratorAttribute( Type objectConfiguratorType )
		{
			Guard.IsOfType( typeof(IObjectConfigurator), objectConfiguratorType );
			this.objectConfiguratorType = objectConfiguratorType;
		}

		public Type ObjectConfiguratorType
		{
			get { return objectConfiguratorType; }
		}
	}
}
