using Common.Core.Configuration;
using Microsoft.Practices.ObjectBuilder2;

namespace Common.Unity.Extensions.Configuration
{
	public abstract class PolicyCreatorBase : IObjectCreator<IBuilderPolicy>
	{
		public IBuilderPolicy PolicyInstance
		{
			get { return instance ?? ( instance = CreateInstance() ); }
		}	IBuilderPolicy instance;

		IBuilderPolicy IObjectCreator<IBuilderPolicy>.Instance
		{
			get { return PolicyInstance; }
		}

		protected abstract IBuilderPolicy CreateInstance();
	}
}