using System.Collections.Generic;
using Microsoft.Practices.Unity.Utility;

namespace Common.Unity.Extensions.Entity
{
	class Include
	{
		readonly IEnumerable<Include> includes;

		public Include( string name ) : this( name, new Include[0] )
		{}

		public Include( string name, IEnumerable<Include> includes )
		{
			Guard.ArgumentNotNullOrEmpty( name, "name" );
			Name = name;
			this.includes = includes;
		}

		public string Name { get; set; }

		public IEnumerable<Include> Includes
		{
			get { return includes; }
		}
	}
}