using System;
using System.IO;
using System.Xml.Serialization;
using Common.Core.Serialization;

namespace Common.Unity.Extensions.Serialization
{
	public class XmlSerializationPolicy : SerializationPolicyBase
	{
		public XmlSerializationPolicy( IStreamResolver resolver ) : base( resolver )
		{}

		protected override object Deserialize( Type targetType, Stream stream )
		{
			if ( stream != null )
			{
				using ( stream )
				{
					var serializer = new XmlSerializer( targetType );
					var result = serializer.Deserialize( stream );
					return result;
				}
			}
			return null;
		}
	}
}