using Microsoft.Practices.Unity;

namespace Common.Unity
{
	public static class UnityConfiguration
	{
		static readonly UnityContainerConfigurationCreator creator = new UnityContainerConfigurationCreator();

		public static UnityContainer Create()
		{
			return creator.Create();
		}

		public static UnityContainer Create( string containerName )
		{
			return creator.Create( containerName );
		}

		public static ContainerType Create<ContainerType>( string containerName ) where ContainerType : IUnityContainer, new()
		{
			return creator.Create<ContainerType>( containerName );
		}
	}
}